
calculate.2D.hull.area <- function(x.matrix,y.matrix) {

##########

nudge=0.001
hull.concavity=10000

result=0

###

n.cols=dim(x.matrix)[2]


#####

count=1

# START REPEAT HERE
repeat {

current.xs=x.matrix[,count]
current.ys=y.matrix[,count]

current.xs=na.omit(current.xs)
current.ys=na.omit(current.ys)

#####

if(length(current.xs)==0) { hull.area=NA }

#####

# START IF HERE

if(length(current.xs>0)) {
xy.points=cbind(current.xs,current.ys)
colnames(xy.points)=c("x","y")

n.points=dim(xy.points)[1]

###

#for 3 point data sets, set 4 point minimum
if(n.points==3) {
xy.points=rbind(xy.points,xy.points)
xy.points=xy.points[-6,]
xy.points=xy.points[-5,]
xy.points[4,1]=xy.points[4,1]+nudge
xy.points[4,2]=xy.points[4,2]+nudge }


#for 2 point data sets, set 4 point minimum
if(n.points==2) {
xy.points=rbind(xy.points,xy.points)
xy.points[3,1]=xy.points[3,1]+nudge
xy.points[3,2]=xy.points[3,2]+nudge
xy.points[4,1]=xy.points[4,1]-nudge
xy.points[4,2]=xy.points[4,2]-nudge }

#for 1 point data sets, set 4 point minimum
if(n.points==1) {
xy.points=rbind(xy.points,xy.points,xy.points,xy.points)
xy.points[2,1]=xy.points[2,1]+nudge
xy.points[2,2]=xy.points[2,2]+nudge
xy.points[3,1]=xy.points[3,1]-nudge
xy.points[3,2]=xy.points[3,2]-nudge
xy.points[4,1]=xy.points[4,1]+nudge+nudge
xy.points[4,2]=xy.points[4,2]+nudge+nudge }

###

my.2D.hull=concaveman(xy.points,concavity=hull.concavity,length_threshold=0)
n.hull.points=dim(my.2D.hull)[1]

if(n.hull.points==3) {
xy.points[1,1]=xy.points[1,1]+nudge
xy.points[1,2]=xy.points[1,2]-nudge
my.2D.hull=concaveman(xy.points,concavity=hull.concavity,length_threshold=0) }

###

my.polygon.stats=Polygon(my.2D.hull,hole=as.logical(NA))
hull.area=my.polygon.stats@area

}
# END IF HERE

#####

result=c(result,hull.area)

count=count+1
if(count==n.cols+1) break }
# END REPEAT HERE

###

result=result[-1]
names(result)=colnames(x.matrix)

##########

return(result) }






