
tree.with.node.numbers.to.pdf <- function(tree) {

##########

n.tips=length(tree$tip.label)
n.nodes=as.numeric(tree$Nnode)
root.node=n.tips+1
last.node=root.node+n.nodes-1

tip.seq=seq(from=1,to=n.tips,by=1)
node.seq=seq(from=root.node,to=last.node,by=1)

###

orig.names=tree$tip.label
new.names=paste(orig.names,"_",tip.seq,sep="")

tree2=tree

tree2$tip.label=new.names
tree2$node.label=node.seq

###

pdf(file="tree.with.node.numbers.pdf",width=7.5,height=10)
plot.phylo(tree2,show.node.label=T,no.margin=T,cex=0.25,edge.width=0.25,underscore=T)
dev.off()

##########

msg="done"

return(msg) }

