
###

plot_tree_with_tip_numbers <- function(tree,fontpercent=1) {

#########################

n_tips=length(tree$tip.label)
tip_numbers=seq(from=1,to=n_tips,by=1)
tip_names=tree$tip.label
tip_numbers_v_names=as.matrix(cbind(tip_names,tip_numbers))

combined_matrix=cbind(tip_numbers_v_names,tip_numbers_v_names)
combined_matrix=combined_matrix[,-4]
combined_matrix[,3]=NA
colnames(combined_matrix)=c("tip_name","tip_number","name_number")

combined_matrix[,3]=paste(combined_matrix[,1],"_",combined_matrix[,2],sep="")
new_tip_names=combined_matrix[,3]

tree2=tree
tree2$tip.label=new_tip_names

dev.new(width=15,height=7)
plot.phylo(tree2,direction="upwards",no.margin=TRUE,cex=fontpercent)

response="done"

#########################

return(response) }

