
tree.with.edge.numbers.to.pdf <- function(tree) {

##########

n.edges=length(tree$edge.length)
edge.numbers=seq(from=1,to=n.edges,by=1)

###

pdf(file="tree.with.edge.numbers.pdf",width=7.5,height=10)
plot.phylo(tree,no.margin=T,cex=0.25,edge.width=0.25,underscore=T)
edgelabels(edge.numbers,frame="none",col="black",bg="none",cex=0.25)
dev.off()

##########

msg="done"

return(msg) }

